﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Wecker
{
    abstract class Meeting
    {
        string title;
        int h;
        int m;

        static int n;

        public Meeting(string title, int h, int m)
        {
            this.title = title;
            this.h = h;
            this.m = m;

            n++;
        }

        public override string ToString()
        {
            string s = h.ToString("D2") + ":" + m.ToString("D2") + " " + title;
            return s;
        }

        public abstract void Ring();

        public bool IsActive()
        {
            DateTime d = DateTime.Now;
            return d.Hour == h && d.Minute == m;
        }
    }

    class MeetingColor : Meeting
    {
        MainWindow mw;
        System.Windows.Threading.DispatcherTimer timer = new System.Windows.Threading.DispatcherTimer();

        public MeetingColor(string title, int h, int m, MainWindow mw)
            : base(title, h, m)
        {
            this.mw = mw;

            timer.Interval = TimeSpan.FromSeconds(10);
            timer.Tick += ringOff;
        }

        void ringOff(object sender, EventArgs e)
        {
            mw.Background = System.Windows.Media.Brushes.White;
            timer.Stop();
        }

        public override void Ring()
        {
            mw.Background = System.Windows.Media.Brushes.Red;
            timer.Start();
        }

        public override string ToString()
        {
            return "F " + base.ToString();
        }
    }

    class MeetingSound : Meeting
    {
        public MeetingSound(string title, int h, int m)
            : base(title, h, m)
        {
        }

        public override void Ring()
        {
            System.Media.SystemSounds.Beep.Play();
        }

        public override string ToString()
        {
            return "K " + base.ToString();
        }
    }
}
